=== debian/changelog ===
supertuxkart (1.4+dfsg-5) unstable; urgency=medium

  * Install missing Cantarell font. (Closes: #1098701)
  * Bump Standards version to 4.7.1, no changes required.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 23 Feb 2025 01:08:39 -0800

supertuxkart (1.4+dfsg-4) unstable; urgency=medium

  [ Reiner Herrmann ]
  * Use system shaderc instead of embedded copy. (Closes: #1057463, #1031387)
  * Use system angelscript instead of embedded copy. (Closes: #995771)

  [ Vincent Cheng ]
  * Declare versioned build-dep on glslang-dev. (Closes: #1031386)
  * Bump Standards version to 4.7.0, no changes required.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 26 Apr 2024 07:04:48 -0700

supertuxkart (1.4+dfsg-3) unstable; urgency=medium

  [ Reiner Herrmann ]
  * Fix FTBFS with gcc 13. (Closes: #1037868)

 -- Vincent Cheng <vcheng@debian.org>  Sun, 16 Jul 2023 01:00:09 -0700

supertuxkart (1.4+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * As per Debian Policy 7.8 and the GPL, document which version of libsimde-dev
    was used to build the binary package.

  [ Sam Q ]
  * Drop symlinks to fonts in large font packages and drop dependencies on
    them. This will use the distributed font copies, but allows one to save
    more than 400 MB of dependencies. (Closes: #975575)

  [ Reiner Herrmann ]
  * Replace obsolete build dependencies.
  * Bump Standards-Version to 4.6.2.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 28 Feb 2023 23:00:54 +0100

supertuxkart (1.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - drop patches applied upstream
    - drop new embedded libraries that are available in Debian and build
      STK with the system libraries
    - drop auto-generated help files from source tarball
  * Bump Standards-Version to 4.6.1.
  * Remove Sam Hocevar from uploaders list as requested by MIA team.
    Thanks to Sam for maintaining STK in the past. (Closes: #1011587)
  * Prevent installation of files from the updated angelscript.
  * Update copyrights.
  * Drop repack count from d/watch.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 09 Jan 2023 12:20:10 +0100
